import java.util.Arrays;
import java.util.List;

/**
 * Quick-sort.
 * @author Pawel P. Wozniak
 */
public class QS_double 
{
    private double[] QSciag;
    private int[] Index;
    
    /**
     * @return table of sorted indexes
     */
    public int[] getIndex() 
    {
		return Index.clone();
	}

    /**
     * @return table of sorted values
     */
	public double[] getQSciag() 
    {
		return QSciag.clone();
	}

	private int partition(int p, int q)
    {
        double x = QSciag[p];
        int i = p;
        
        for (int j=p+1;j<=q;j++)
        {
            if (QSciag[j] >= x)
            {
                i++;
                
                if (i != j)
                {
                	swap(i, j);
                }
            }
        }
        
        if(i != p)
        {
        	swap(i, p);
        }
        
        return i;
    }

	private void swap(int i, int j)
	{
		double temp;
        int IndexTemp;
		
		temp = QSciag[i];
        QSciag[i] = QSciag[j];
        QSciag[j] = temp;
        
        IndexTemp = Index[i];
        Index[i] = Index[j];
        Index[j] = IndexTemp;
	}
	
	@SuppressWarnings("unused")
	private int threeWayPartition(int p, int q)
    {
        double x = QSciag[p];
        int i = p;
        int j = p;
        int n = q;
        
        while(j <= n)
        {
        	if(QSciag[j] > x)
        	{
        		swap(i,j);
        		i++;
        		j++;
        	}
        	else if(QSciag[j] < x)
        	{
        		swap(j,n);
        		n--;
        	}
        	else
        	{
        		j++;
        	}
        }
        return i;
    }
	
	@SuppressWarnings("unused")
	private int pivotTheChosenOne(int p, int q)
    {
		/*
		int swapIndex = p;
		for(int i=p;i<q;i++)
        {
			if(QSciag[i] != QSciag[i+1])
			{
				swapIndex = i;
				break;
			}
        }
		*/
		int middle = p+((q-p)/2);
		double[] medianOfThree = new double[3];
		medianOfThree[0] = QSciag[p];
		medianOfThree[1] = QSciag[q];
		medianOfThree[2] = QSciag[middle];
		Arrays.sort(medianOfThree);
		double median = medianOfThree[1];
		int swapIndex;
		if(QSciag[p] == median)
		{
			swapIndex = p;
		}
		else if(QSciag[q] == median)
		{
			swapIndex = q;
		}
		else
		{
			swapIndex = middle;
		}
		
		if(swapIndex != p && swapIndex>=p && swapIndex<=q)
		{
			double tmp = QSciag[p];
			QSciag[p] = QSciag[swapIndex];
			QSciag[swapIndex] = tmp;
		}
		
        return partition(p, q);
    }
	
	private boolean ifAllTheSame(int p, int q)
	{
		for(int i=p;i<q;i++)
        {
			if(QSciag[i] < QSciag[i+1])
			{
				return false;
			}
        }
		return true;
	}
	
    private void sort(int p, int q)
    {
    	if(ifAllTheSame(p,q))
    	{
    		return;
    	}
    	
        int r;
        if (p < q)
        {
        	//r = threeWayPartition(p,q);
            r = partition(p,q);
            
            sort(p,r-1);
   
            sort(r+1,q);
        }
        return;
    }
    
    <E> QS_double(List<E> A)
    {
        QSciag = new double[A.size()];
        int ALength = A.size();
        for(int i=0;i<ALength;i++)
        {
            QSciag[i] = Double.parseDouble(String.valueOf(A.get(i)));
        }
        IndexInit();
        sort(0, QSciag.length-1);    
    }

	QS_double(double[] dI) 
	{
		QSciag = dI.clone();
        IndexInit();
		sort(0, QSciag.length-1);
	}
	
	private void IndexInit()
	{
		int QSlength = QSciag.length;
		Index = new int[QSlength];
		for(int i=0; i<QSlength; i++)
		{
			Index[i] = i;
		}
	}
}
