import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.charset.Charset;

/**
 * @author Pawel P. Wozniak
 * Gives a whole containing of a file in a single String.
 */
public class ReadFile 
{
	private String FullText;
	
	/**
	 * @return whole containing of a file
	 */
	public String getFullText() 
	{
		return FullText;
	}
	
	/**
	 * @param path - path to the file
	 * @throws IOException
	 */
	ReadFile(String path) throws IOException 
	{
		FileInputStream stream = new FileInputStream(new File(path));
		try
		{
			FileChannel fc = stream.getChannel();
		    MappedByteBuffer bb = fc.map(FileChannel.MapMode.READ_ONLY, 0, fc.size());
		    FullText = Charset.defaultCharset().decode(bb).toString();
		}
		finally
		{
		    stream.close();
		}
	}
}
